package JointFeldmanProtocol;

/**
 * Created by Tzlil on 2/5/2016.
 */
public interface Network extends Iterable<Network.User>{

    User connect();

    interface User{
        int getID();
        void send(int userID,Message message);
        void sendBroadcast(Message message);
        void receive(int userID,Message message);
        void receiveBroadcast(Message message);
        Network getNetwork();
    }

    interface Message{
        enum Type {
            Commitment, Share, Complaint, Y
        }

        Type getType();

    }
}
